#include "FreeRTOS.h"
#include "task.h"

#include "stm32f4xx.h"

#define TASK1_PRIORITY	(tskIDLE_PRIORITY + 1)
#define TASK2_PRIORITY	(tskIDLE_PRIORITY + 1)
#define TASK3_PRIORITY	(tskIDLE_PRIORITY + 1)

xTaskHandle hTASK1;
xTaskHandle hTASK2;
xTaskHandle hTASK3;

portTASK_FUNCTION_PROTO(Task1, pvParameters);
portTASK_FUNCTION_PROTO(Task2, pvParameters);
portTASK_FUNCTION_PROTO(Task3, pvParameters);

void GPIOInit(void);


int main(void)
{
	GPIOInit();

	xTaskCreate(Task1, (signed char *)"Task1", configMINIMAL_STACK_SIZE, NULL, TASK1_PRIORITY, &hTASK1);
	xTaskCreate(Task2, (signed char *)"Task2", configMINIMAL_STACK_SIZE, NULL, TASK2_PRIORITY, &hTASK2);
	xTaskCreate(Task3, (signed char *)"Task3", configMINIMAL_STACK_SIZE, NULL, TASK3_PRIORITY, &hTASK3);

	vTaskStartScheduler();

    while(1)
    {
    }
}

/*
 * GPIO Init
 */
void GPIOInit(void)
{
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);

	GPIO_InitTypeDef GPIOD_12_13_14;

	GPIOD_12_13_14.GPIO_Mode = GPIO_Mode_OUT;
	GPIOD_12_13_14.GPIO_OType = GPIO_OType_PP;
	GPIOD_12_13_14.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14;
	GPIOD_12_13_14.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIOD_12_13_14.GPIO_Speed = GPIO_Speed_50MHz;

	GPIO_Init(GPIOD, &GPIOD_12_13_14);

	GPIO_WriteBit(GPIOD, GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14, Bit_SET);
}

/*
 * Tasks
 */
portTASK_FUNCTION(Task1, pvParameters)
{
	int i;

	for(i = 0; i < 100; i++)
	{
		GPIO_ToggleBits(GPIOD, GPIO_Pin_13);

		int j;
		for(j = 0; j < 100000; j++);
	}

	vTaskDelete(&hTASK1);
}

portTASK_FUNCTION(Task2, pvParameters)
{
	while(1)
	{
		GPIO_ToggleBits(GPIOD, GPIO_Pin_12);

		int i;
		for(i = 0; i < 100000; i++);
	}
}

portTASK_FUNCTION(Task3, pvParameters)
{
	while(1)
	{
		GPIO_ToggleBits(GPIOD, GPIO_Pin_14);

		int i;
		for(i = 0; i < 100000; i++);
	}
}


/*
 * FreeRTOS Callbacks
 */
void vApplicationStackOverflowHook(void)
{
}


